varying highp vec2 var_texcoord0;
varying highp vec4 var_color;

uniform highp sampler2D texture_;
uniform highp vec4 alpha;

highp float rgba_to_float(highp vec4 rgba)
{
    return dot(rgba, vec4(1.0, 1.0/255.0, 1.0/65025.0, 1.0/16581375.0));
}

void main()
{
    highp vec4 result_color_RGBA = texture2D(texture_, var_texcoord0.xy);
    highp float d = rgba_to_float(result_color_RGBA);
    result_color_RGBA = vec4(d, fract(d*5.0), fract(d*25.0), 1.0);

    gl_FragColor = result_color_RGBA;
}
